// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//  Giuseppe Vacanti (cosine science & computing bv)
//  July 29, 2002
// 
//   $Id: singleton_test.cc,v 1.3 2008/09/26 16:38:55 eojero Exp $
#include <Singleton.h>

#include <iostream>

using namespace Loki;

class A {
public:
    A() { std::cout << "Created A" << std::endl; }
    void tell() const { std::cout << this << std::endl; }
	const A *signature() const { return this; }
};

typedef SingletonHolder<A> SingleA;

int main() {
    std::cout << "main" << std::endl;
    SingleA::Instance().tell();
	assert(SingleA::Instance().signature() == SingleA::Instance().signature());
}
    
