// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
//
// XMM Science Analysis System
//
// Giuseppe Vacanti (cosine science & computing) 
// November 2001
//
// $Id: teststringutilioexceptions.cc,v 1.4 2008/09/26 16:38:55 eojero Exp $
#include<iostream>
#include<stringutil.h>
#include<string>

int main() {

  std::string str("abc");
  std::string number("1234.5");

  bool fail = true;
  try {
    int x = toNumber<int>(str);
    std::cout << "string (" << str << ") to int -> " << x << std::endl;
  }
  catch(std::string e) {
    std::cout << "caught bad string to int conversion" << std::endl;
    std::cout << "*** " << e << std::endl;
    fail = false;
  }

  if(fail)
    std::cerr << "try-catch block failed" << std::endl;

  try {
    int x = toNumber<int>(number);
    std::cout << "number (" << number << ") to int -> " << x << std::endl;
  }
  catch(...) {
    std::cout << "float to int conversion failed" << std::endl;
    exit(1);
  }

  try {
    double x = toNumber<double>(number);
    std::cout << "number (" << number << ") to double -> " << x << std::endl;
  }
  catch(...) {
    std::cout << "float to double conversion failed" << std::endl;
    exit(1);
  }

  if(fail)
    exit(1);

}  
    
    
